%define anolis_release 2.2

%define debug_package %{nil}
%define product_family Anolis OS
%define base_release_version 8
%define full_release_version 8.8
%define compat_release_version 8
%define dist .an%{base_release_version}
%define cloud_provider aliyuncs
%define cloud_provider_mirror http://mirrors.cloud.aliyuncs.com
%define real_name anolis

Name:           anolis-release-%{cloud_provider}
Version:        %{full_release_version}
Release:        %{anolis_release}%{?dist}
Summary:        %{product_family} %{base_release_version} release file
Group:          System Environment/Base
License:        MulanPSLv2
Obsoletes:      rawhide-release redhat-release-as redhat-release-es redhat-release-ws redhat-release-de comps rpmdb-redhat fedora-release redhat-release centos-release
Conflicts:      anolis-release
Provides:       redhat-release = %{full_release_version}
Provides:       centos-release = %{full_release_version}
Provides:       system-release = %{version}-%{release}
Provides:       system-release(releasever) = %{base_release_version}
Provides:       anolis-release = %{full_release_version}

Requires:       anolis-gpg-keys-%{cloud_provider} = %{version}-%{release}
Requires:       anolis-repos-%{cloud_provider} >= %{version}-%{release}

Source0:        EULA
Source1:        MulanPSL
Source2:	RPM-GPG-KEY-ANOLIS

Source10:	85-display-manager.preset
Source11:	90-default.preset
Source12:	99-default-disable.preset

Source100:	AnolisOS-BaseOS.repo
Source101:	AnolisOS-AppStream.repo
Source102:	AnolisOS-PowerTools.repo
Source103:	AnolisOS-Plus.repo
Source104:      AnolisOS-DDE.repo
Source105:      AnolisOS-Source.repo
Source106:      AnolisOS-Debuginfo.repo
Source107:      AnolisOS-HighAvailability.repo
Source108:      AnolisOS-Extras.repo
Source109:      AnolisOS-kernel-5.10.repo

%description
%{product_family} %{base_release_version} release files for cloud provider aliyun


%package -n anolis-repos-%{cloud_provider}
Summary:        %{product_family} package repositories
Group:          System Environment/Base
Obsoletes:      anolis-latest-repos
Conflicts:      anolis-repos
Provides:       anolis-repos(%{base_release_version}) = %{full_release_version}
Requires:       system-release = %{full_release_version}
Requires:       anolis-gpg-keys-%{cloud_provider} = %{version}-%{release}

%description -n anolis-repos-%{cloud_provider}
%{product_family} package repository files for yum and dnf on cloud provider aliyun

%package -n anolis-gpg-keys-%{cloud_provider}
Summary:        %{product_family} RPM keys
Group:          System Environment/Base
BuildArch:      noarch
Conflicts:      anolis-gpg-keys

%description -n anolis-gpg-keys-%{cloud_provider}
%{product_family} RPM signature keys for cloud provider aliyun

%prep
echo OK

%build
echo OK

%install
rm -rf %{buildroot}

# create /etc
mkdir -p %{buildroot}/etc

# create /etc/system-release
echo "%{product_family} release %{full_release_version}" > %{buildroot}/etc/%{real_name}
ln -s %{real_name} %{buildroot}/etc/system-release

# create /etc/os-release
cat << EOF >>%{buildroot}/etc/os-release
NAME="%{product_family}"
VERSION="%{full_release_version}"
ID="anolis"
ID_LIKE="rhel fedora centos"
VERSION_ID="%{full_release_version}"
PLATFORM_ID="platform:an%{base_release_version}"
PRETTY_NAME="%{product_family} %{full_release_version}"
ANSI_COLOR="0;31"
HOME_URL="https://openanolis.cn/"

EOF
# write cpe to /etc/system/release-cpe

# create /etc/issue and /etc/issue.net
echo '\S' > %{buildroot}/etc/issue
echo 'Kernel \r on an \m' >> %{buildroot}/etc/issue
cp %{buildroot}/etc/issue %{buildroot}/etc/issue.net
echo >> %{buildroot}/etc/issue

# copy GPG keys
mkdir -p -m 755 %{buildroot}/etc/pki/rpm-gpg
install -m 644 %{SOURCE2} %{buildroot}/etc/pki/rpm-gpg

# copy yum repos
mkdir -p -m 755 %{buildroot}/etc/yum.repos.d
install -m 644 %{SOURCE100} %{buildroot}/etc/yum.repos.d
install -m 644 %{SOURCE101} %{buildroot}/etc/yum.repos.d
install -m 644 %{SOURCE102} %{buildroot}/etc/yum.repos.d
install -m 644 %{SOURCE103} %{buildroot}/etc/yum.repos.d
install -m 644 %{SOURCE104} %{buildroot}/etc/yum.repos.d
install -m 644 %{SOURCE105} %{buildroot}/etc/yum.repos.d
install -m 644 %{SOURCE106} %{buildroot}/etc/yum.repos.d
install -m 644 %{SOURCE107} %{buildroot}/etc/yum.repos.d
install -m 644 %{SOURCE108} %{buildroot}/etc/yum.repos.d
install -m 644 %{SOURCE109} %{buildroot}/etc/yum.repos.d

sed -i "s#http://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE100})
sed -i "s#http://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE101})
sed -i "s#http://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE102})
sed -i "s#http://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE103})
sed -i "s#http://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE104})
sed -i "s#http://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE105})
sed -i "s#http://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE106})
sed -i "s#http://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE107})
sed -i "s#http://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE108})
sed -i "s#http://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE109})

sed -i "s#https://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE100})
sed -i "s#https://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE101})
sed -i "s#https://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE102})
sed -i "s#https://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE103})
sed -i "s#https://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE104})
sed -i "s#https://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE105})
sed -i "s#https://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE106})
sed -i "s#https://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE107})
sed -i "s#https://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE108})
sed -i "s#https://mirrors.openanolis.cn#%{cloud_provider_mirror}#" %{buildroot}/etc/yum.repos.d/$(basename %{SOURCE109})

# set up the dist tag macros
install -d -m 755 %{buildroot}/etc/rpm
cat >> %{buildroot}/etc/rpm/macros.dist << EOF
# dist macros.

%%anolis_ver %{base_release_version}
%%anolis     %{base_release_version}
%%anolis%{base_release_version} 1
%%dist %dist
# For compatibility
%%rhel %{compat_release_version}
%%el%{compat_release_version} 1
EOF

# use unbranded datadir
mkdir -p -m 755 %{buildroot}/%{_datadir}/%{real_name}
install -m 644 %{SOURCE0} %{buildroot}/%{_datadir}/%{real_name}

# use unbranded docdir
mkdir -p -m 755 %{buildroot}/%{_docdir}/%{real_name}
install -m 644 %{SOURCE1} %{buildroot}/%{_docdir}/%{real_name}

# copy systemd presets
mkdir -p %{buildroot}/%{_prefix}/lib/systemd/system-preset/
install -m 0644 %{SOURCE10} %{buildroot}/%{_prefix}/lib/systemd/system-preset/
install -m 0644 %{SOURCE11} %{buildroot}/%{_prefix}/lib/systemd/system-preset/
install -m 0644 %{SOURCE12} %{buildroot}/%{_prefix}/lib/systemd/system-preset/

%clean
rm -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
/etc/system-release
/etc/%{real_name}
%config(noreplace) /etc/os-release
%config(noreplace) /etc/issue
%config(noreplace) /etc/issue.net
%{_prefix}/lib/systemd/system-preset/*
/etc/rpm/macros.dist
%{_docdir}/%{real_name}
%{_datadir}/%{real_name}

%files -n anolis-repos-%{cloud_provider}
%config(noreplace) /etc/yum.repos.d/*

%files -n anolis-gpg-keys-%{cloud_provider}
/etc/pki/rpm-gpg/

%post -n anolis-repos-%{cloud_provider}
if [[ `uname -r` =~ "5.10".* ]];then
    if [[ -f /etc/yum.repos.d/AnolisOS-kernel-5.10.repo ]];then
        sed -i "s/enabled=0/enabled=1/g" /etc/yum.repos.d/AnolisOS-kernel-5.10.repo
    fi
elif [[ `uname -r` =~ "4.19".* ]];then
    if [[ -f /etc/yum.repos.d/AnolisOS-Plus.repo ]];then
        sed -i "s/enabled=0/enabled=1/g" /etc/yum.repos.d/AnolisOS-Plus.repo
    fi
fi


%changelog
* Fri Mar 03 2023 Weitao Zhou <zhouwt@linux.alibaba.com> - 8.8-2.2
- Name the pkg with same convention

* Mon Feb 20 2023 Weitao Zhou <zhouwt@linux.alibaba.com> - 8.8-2.1
- Init anolis release for cloud provider aliyun

* Mon Dec 19 2022 Chang Gao <gc-taifu@linux.alibaba.com> - 8.8-2
- Split 5.10 kernel into independent repo

* Thu Dec 8 2022 Chang Gao <gc-taifu@linux.alibaba.com> - 8.8-1
- Update to 8.8

* Tue Nov  8 2022 Liwei Ge <geliwei@openanolis.org> - 8.6-4
- Remove compatible symbolic link

* Sat Jun 18 2022 Caspar Zhang <caspar@linux.alibaba.com> - 8.6-3
- Obsoletes anolis-latest-repos

* Fri Jun 10 2022 Xiaoping Liu <lxp01404969@alibaba-inc.com> - 8.6-2
- Remove Experimental repo

* Tue Apr 12 2022 Liwei Ge <liwei.glw@linux.alibaba.com> - 8.6-1
- Update to 8.6

* Fri Mar 11 2022 Liwei Ge <liwei.glw@linux.alibaba.com> - 8.5-2
- Add Experimental repo

* Tue Jan 25 2022 Weitao Zhou <zhouwt@linux.alibaba.com> - 8.5-1
- Update to 8.5

* Tue Jan 25 2022 Weitao Zhou <zhouwt@linux.alibaba.com> - 8.4-7
- Use var releasever instead of hardcode in repo baseurl

* Mon Oct 11 2021 Liwei Ge <geliwei@openanolis.org> - 8.4-6
- Update license to MulanPSLv2
- Translate EULA to Chinese
- Add Extras repo

* Mon Aug  9 2021 Liwei Ge <geliwei@openanolis.org> - 8.4-5
- Disable audit by default

* Fri Jul 23 2021 Liwei Ge <geliwei@openanolis.org> - 8.4-4
- Provides centos-release
- Remove duplicate RPMS repo
- Add HighAvailability repo

* Wed Jul 21 2021 yangxiaoxuan <yangxiaoxuan@openanolis.org> - 8.4-3
- Add Debug and Source repo file

* Fri Jul 02 2021 Peng Zhou <zhoupeng@openanolis.org> - 8.4-2
- Yum repo url to point to distro's RPMs repo rather than composed from var releasever

* Fri Jun 18 2021 Liwei Ge <geliwei@openanolis.org> - 8.4-1
- Update to 8.4

* Thu Jun 03 2021 yangxiaoxuan <yangxiaoxuan@openanolis.org> - 8.2-8
- Modify the mirror url of the repo file

* Wed May 19 2021 Hang Zhao <1209176326@qq.com> - 8.2-9
- Update openanolis url
- Add DDE repo

* Fri Apr 16 2021 Liwei Ge <geliwei@openanolis.org> - 8.2-8
- Add Plus repo
- Fix location of EULA

* Thu Apr  8 2021 Liwei Ge <geliwei@openanolis.org> - 8.2-7
- Update system-release pattern

* Tue Mar 30 2021 mahailiang <mahailiang@openanolis.org> - 8.2-6
- update preset files

* Tue Mar 16 2021 Liwei Ge <geliwei@openanolis.org> - 8.2-5
- Add PowerTools repo

* Fri Mar  5 2021 Liwei Ge <geliwei@openanolis.org> - 8.2-4
- Update EULA for Anolis OS

* Thu Mar  4 2021 Liwei Ge <geliwei@openanolis.org> - 8.2-3
- Fix repo url

* Wed Mar  3 2021 Liwei Ge <geliwei@openanolis.org> - 8.2-2
- Update repo url and add public key

* Tue Jan 19 2021 Liwei Ge <geliwei@openanolis.org> - 8.2-1
- Init version of anolis-release
